<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Mapping Pipeline: Mapping Pipeline</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Mapping Pipeline
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Mapping Pipeline </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>Version: 4.1.0 <br />
 Contact: <a href="#" onclick="location.href='mai'+'lto:'+'BI-'+'Su'+'ppo'+'rt'+'@rk'+'i.'+'de'; return false;">BI-Su<span style="display: none;">.nosp@m.</span>ppor<span style="display: none;">.nosp@m.</span>t@rki<span style="display: none;">.nosp@m.</span>.de</a> <br />
 25.07.2017</p>
<h2>Editing this page</h2>
<p>This is a copy of the <code>README.md</code> of the main directory.</p>
<p>The includes of <code>mapping_flow.png</code> and <code>report.png</code> need to be changed from <code>./*.png</code> to <code>../../*.png</code>.</p>
<p>In contrast to the main <code>README.md</code>, this one also includes a flowchart of the pipeline.</p>
<p>It was created with <a href="http://draw.io">draw.io</a> and can be edited by loading the <code>mapping_fc.xml</code> file on the website.</p>
<hr/>
 <h2>Introduction</h2>
<p>This pipeline is used for mapping Next Generation Sequencing (NGS) reads of one or more samples automatically to a reference sequence (or a set thereof). Both raw Illumina read folders and trimmed read folders from <a href="https://gitlab.com/RKIBioinformaticsPipelines/QualityControl">QCumber</a> can be used as input for the batch processing mode. The pipeline was implemented in Python (requiring Python 3.4 or higher to run) and uses the following tools:</p>
<table class="doxtable">
<tr>
<th>Tool name </th><th>Version </th><th>Pubmed ID  </th></tr>
<tr>
<td><a href="http://bowtie-bio.sourceforge.net/bowtie2/index.shtml">Bowtie2*</a> </td><td>2.3 </td><td><a href="https://www.ncbi.nlm.nih.gov/pubmed/22388286">22388286</a> </td></tr>
<tr>
<td><a href="http://bio-bwa.sourceforge.net/">BWA*</a> </td><td>0.7.15 </td><td><a href="https://www.ncbi.nlm.nih.gov/pubmed/20080505">20080505</a> </td></tr>
<tr>
<td><a href="https://www.latex-project.org/">Latex</a> </td><td>2.6 </td><td></td></tr>
<tr>
<td><a href="http://www.htslib.org/">Samtools</a></td><td>1.3.1 </td><td><a href="https://www.ncbi.nlm.nih.gov/pubmed/19505943">19505943</a> </td></tr>
<tr>
<td>RefFinder </td><td>2.1.2 </td><td><a href="https://portal.rki.local/cocoon/portal/portallink?doctype=Navknoten&amp;id=1340">Stephan Fuchs, FG13</a> </td></tr>
<tr>
<td><a href="https://broadinstitute.github.io/picard/">Picard</a> </td><td>2.7.1 </td><td></td></tr>
</table>
<p>*At least one of the mapping softwares is needed.</p>
<p>The pipeline requires the following Python packages:</p><ul>
<li>jinja2</li>
<li>matplotlib</li>
<li>scipy</li>
<li>numpy</li>
<li>pyyaml</li>
<li>pysam</li>
</ul>
<p>The workflow of the pipeline is shown in the figure below:</p>
<div class="image">
<img src="../../mapping_flow.png" alt="Workflow of the mapping pipeline."/>
</div>
<p>This is a flowchart representing the inner workings of the pipeline:</p>
<div class="image">
<img src="mapping_fc.png" alt="mapping_fc.png"/>
<div class="caption">
Flowchart of the mapping pipeline.</div></div>
 <hr/>
 <h2>Tutorial</h2>
<p>This tutorial works with trimmed reads generated in the QCumber tutorial. The files are available on sebio04 or sebio05 in the folder <code>/pipelines/datasets/QCResults</code>. The outcome of QCumber contains four <code>"fastq.gz"</code> files per sample. The prefixes <code>1P</code> and <code>2P</code> denote the first and second reads of read pairs, respectively. In case one of the read pairs did not survive trimming, its “orphaned” reads are contained in the files starting with <code>1U</code> (read 1) or <code>2U</code> (read 2), respectively. A reference sequence is available at <code>pipelines/datasets/references/toy_reference.gb</code>.</p>
<p>To obtain a list of all parameters, the pipeline can be invoked with the command <code>mapping-4 -h</code>.</p>
<p>The following command can be used to run the mapping pipeline on the test dataset:</p>
<div class="fragment"><div class="line">mapping-4 --mapper bowtie2 --input /pipelines/datasets/QCResults/ --output mapping_outcome/ --reference /pipelines/datasets/references/toy_reference.gb --join_sample</div></div><!-- fragment --><p> Please note that the command needs to be entered in a single line, without line breaks. The arguments in the above command have the following meaning:</p><ul>
<li><code>--mapper bowtie2</code>: The name of the mapper of choice (the alternative is bwa-mem).</li>
<li><code>--input</code>: The input folder containing the read files.</li>
<li><code>--output</code>: The output folder.</li>
<li><code>--options</code>: Parameters passed directly to the mapper (bowtie2 in this case).</li>
<li><code>--join_sample</code>: Join the alignment files for each sample. There are several files per sample from the QCumber output. These are mapped separately, which generates several output sam files per sample. This option requires the mapping pipeline to join all sam files generated for each sample into a single file.</li>
<li><code>--reference</code>: The reference sequence to map against.</li>
</ul>
<p>Once the pipeline has finished its computations, you can find the output in the mapper_output folder. In case of <code>--join_sample</code> option, one PDF report ("mapping\_UP\_&lt;samplename&gt;.pdf") and one sam mapping file ("UP\_&lt;samplename&gt;.sam") will be generated for each sample. In absence of the <code>--join_sample</code> argument, separated sample files for paired reads (<code>P</code>), unpaired read 1 (<code>1U</code>) and unpaired read 2 (<code>2U</code>) will be generated, along with the corresponding PDF reports.</p>
<p>Below please find some further usage examples:</p>
<div class="fragment"><div class="line">mapping-4 --mapper bwa-mem --reference &lt;path&gt;/reference1.fasta --reference &lt;path&gt;/reference2.gb --read1 &lt;path&gt;/read1.fastq --read2 &lt;path&gt;/read2.fastq --output &lt;path&gt; --options &quot;-M&quot;</div></div><!-- fragment --><div class="fragment"><div class="line">mapping-4 --mapper bwa-mem --read1 &lt;path&gt;/read1.fastq --read2 &lt;path&gt;/read2.fastq --option &quot;-x /index/bwa&quot;</div></div><!-- fragment --><div class="fragment"><div class="line">mapping-4 --mapper bowtie2 --input &lt;path&gt;/to/project --reference &lt;path&gt;/to/reference --join &lt;path/to/picard&gt;</div></div><!-- fragment --> <hr/>
 <h2>Options</h2>
<p>The following paragraphs describe the options of the pipeline in detail.</p>
<h4>Input</h4>
<blockquote class="doxtable">
<p>Long option: <code>--input &lt;INPUT&gt;</code> <br />
 Short option: <code>-i &lt;INPUT&gt;</code> </p>
</blockquote>
<p>Input mapping files. The input can be:</p><ul>
<li>a fastq file containing the forward reads given by the <code>--read1</code> parameter. The corresponding fastq file containing reverse reads can be given using the <code>--read2</code> parameter</li>
<li>a folder containing raw MiSeq data (fastq.gz files named following the default MiSeq naming scheme) given by the <code>--input</code> parameter</li>
<li>the "Trimmed" output folder of QCumber given by <code>--input</code> parameter</li>
</ul>
<h4>Read1</h4>
<blockquote class="doxtable">
<p>Long option: <code>--read1 &lt;READ1&gt;</code> <br />
 Short option: <code>-r1 &lt;READ1&gt;</code> </p>
</blockquote>
<p>Either unpaired reads or first mate of paired reads. Alternatively, select a project folder using <code>--input</code>.</p>
<h4>Reference</h4>
<blockquote class="doxtable">
<p>Long option: <code>--reference &lt;REFERENCE&gt;</code> <br />
 Short option: <code>-r &lt;REFERENCE&gt;</code> </p>
</blockquote>
<p>Reference genome. FASTA or GenBank format. This parameter can be used multiple times to provide multiple sequences (please refer to the option <code>multi-fasta</code> for further information.</p>
<p>GenBank files may be acquired from <a href="http://www.ncbi.nlm.nih.gov/genbank/">NCBI</a>. When downloading GenBank files from NCBI, make sure to include the sequence (<em>Customize view</em> -&gt; <em>Display options</em> -&gt; <em>Show sequence</em>) before downloading the file (<em>Send</em> -&gt; <em>Complete record</em> -&gt; <em>File</em> -&gt; <em>GenBank (full)</em>). Alternatively, reference sequence can be exported as GenBank file from <b>Geneious</b>.</p>
<h4>Help</h4>
<blockquote class="doxtable">
<p>Long option: <code>--help</code> <br />
 Short option: <code>-h</code> </p>
</blockquote>
<p>Show the help messages and exit</p>
<h4>Version</h4>
<blockquote class="doxtable">
<p>Long option: <code>--version</code> <br />
 Short option: <code>-v</code> </p>
</blockquote>
<p>Show program's version number and exit</p>
<h4>No-report</h4>
<blockquote class="doxtable">
<p>Long option: <code>--no-report</code> </p>
</blockquote>
<p>Do not generate report. Default: generate a report.</p>
<h4>Read2</h4>
<blockquote class="doxtable">
<p>Long option: <code>--read2 &lt;READ2&gt;</code> <br />
 Short option: <code>-r2 &lt;READ2&gt;</code> </p>
</blockquote>
<p>Second mate of paired reads.</p>
<h4>Output</h4>
<blockquote class="doxtable">
<p>Long option: <code>--output &lt;OUTPUT&gt;</code> <br />
 Short option: <code>-o &lt;OUTPUT&gt;</code> </p>
</blockquote>
<p>Output location. Default: current working directory <code>./</code></p>
<h4>Threads</h4>
<blockquote class="doxtable">
<p>Long option: <code>--threads &lt;THREADS&gt;</code> <br />
 Short option: <code>-t &lt;THREADS&gt;</code> </p>
</blockquote>
<p>Define number of threads used by mapper. Default: 1</p>
<h4>Log</h4>
<blockquote class="doxtable">
<p>Long option: <code>--log &lt;LOG&gt;</code> <br />
 Short option: <code>-l &lt;LOG&gt;</code> </p>
</blockquote>
<p>Define log file. Default: log file with timestamp in output directory</p>
<h4>Multi-fasta</h4>
<blockquote class="doxtable">
<p>Long option: <code>--multi-fasta</code> </p>
</blockquote>
<p>Per default, multiple sequences of a given reference FASTA file are considered to be different genetic segments (e.g., different chromosomes). In case <code>--multi-fasta</code> is used, the pipeline splits the multi-FASTA file into single FASTA files, and subsequently calls RefFinder (developed by Dr. Stephan Fuchs) to automatically select the best reference.</p>
<h4>Options</h4>
<blockquote class="doxtable">
<p>Long option: <code>--options &lt;OPTIONS&gt;</code> </p>
</blockquote>
<p>The parameter <code>--options</code> can be used to provide further parameters that will be passed directly to the mapper. Please quote the whole parameter string (e.g. <code>--options "--very-sensitive-local"</code> to use the very sensitive local alignment with bowtie2, please refer to the man pages of <code>bowtie2</code> and bwa for respective parameter lists). For both bowtie2 and bwa a pre-defined index can be set by using <code>-x</code> (e.g. <code>--options "-x path/to/index"</code>, note that for bowtie2 and bwa only the basename of the index is given, i.e. no extension). The given index is not deleted.</p>
<h4>Reffinder options</h4>
<blockquote class="doxtable">
<p>Long option: <code>--reffinder_options &lt;REFFINDER_OPTIONS&gt;</code> </p>
</blockquote>
<p>In case multiple references are given as separate FASTA files, this option can be used to provide parameters to "RefFinder" (developed by Dr. Stephan Fuchs) for the determination of the best reference. The parameter string has to be quoted, e.g.: <code>--reffinder_options=″-t 10″</code>.</p>
<h4>Join</h4>
<blockquote class="doxtable">
<p>Long option: <code>--join</code> </p>
</blockquote>
<p>Join all created alignment files into one file. Default: one SAM file per fastq file.</p>
<h4>Join sample</h4>
<blockquote class="doxtable">
<p>Long option: <code>--join_sample</code> </p>
</blockquote>
<p>Join all created alignment files per sample into one file. Default: one SAM file per fastq file.</p>
<h4>No-rg</h4>
<blockquote class="doxtable">
<p>Long option: <code>--no-rg</code> </p>
</blockquote>
<p>Do not set read groups. Default: set distinct read group for each sample.</p>
<h4>Unmapped</h4>
<blockquote class="doxtable">
<p>Long option: <code>--unmapped &lt;UNMAPPED&gt;</code> </p>
</blockquote>
<p>Write unmapped reads to output. Read name will be automatically added. Default: unmapped reads are not outputted.</p>
<h4>Java</h4>
<blockquote class="doxtable">
<p>Long option: <code>--java &lt;JAVA&gt;</code> </p>
</blockquote>
<p>Path to the Java version 1.8+ executable.</p>
<h4>Samtools</h4>
<blockquote class="doxtable">
<p>Long option: <code>--samtools &lt;SAMTOOLS&gt;</code> </p>
</blockquote>
<p>Path to folder containing samtools.</p>
<h4>Bwa</h4>
<blockquote class="doxtable">
<p>Long option: <code>--bwa &lt;BWA&gt;</code> </p>
</blockquote>
<p>Path to folder containg bwa.</p>
<h4>Bowtie2</h4>
<blockquote class="doxtable">
<p>Long option: <code>--bowtie2 &lt;BOWTIE2&gt;</code> </p>
</blockquote>
<p>Path to folder containing bowtie2.</p>
<h4>Picard</h4>
<blockquote class="doxtable">
<p>Long option: <code>--picard &lt;PICARD&gt;</code> </p>
</blockquote>
<p>Path to folder containing picard.jar</p>
<h4>Config</h4>
<blockquote class="doxtable">
<p>Long option: <code>--config &lt;CONFIG&gt;</code> <br />
 Short option: <code>-c &lt;CONFIG&gt;</code> </p>
</blockquote>
<p>Define a config file in yaml format with preset parameters. If both config file and command parameters are given, the parameters given on the commandline supersede the parameters given in the config file. Thus, a config file can be used to personalize default parameters, and deviations from these personal defaults can be given via the command-line.</p>
<p>For instance, in order to run the pipeline with 24 threads using <code>"~/SCRATCH_NOBAK/runs/newest_run"</code> as input, <code>"~/SCRATCH_NOBAK/runs/newest_mappingres"</code> as output and <code>"~/references/myreference.gb"</code> as reference, the following config file could be used (<code>"~/example.yaml"</code>):</p>
<div class="fragment"><div class="line">threads: 24</div><div class="line">input: &quot;~/SCRATCH_NOBAK/runs/newest_run&quot;</div><div class="line">output: &quot;~/SCRATCH_NOBAK/runs/newest_mappingres&quot;</div><div class="line">reference: &quot;~/references/myreference.gb&quot;</div></div><!-- fragment --><p>The pipeline could then be started using the following command:</p>
<div class="fragment"><div class="line">mapping-4 --config ~/example.yaml</div></div><!-- fragment --><p>If then a a run of the pipeline is to be started with the same parameters but with 12 threads, this can be achieved with the following command (re-using the config file and overriding the threads option instead of giving all paramenters on the commandline manually):</p>
<div class="fragment"><div class="line">mapping-4 --config ~/example.yaml --threads 12</div></div><!-- fragment --> <hr/>
 <h4>Output description</h4>
<p>The output folder contains:</p>
<ul>
<li>The mapping file in BAM format</li>
<li>The mapping files (SAM)</li>
<li>PDF reports, as well as the auxiliary tex files</li>
<li>log files are located in the output folder.</li>
<li>A directory <code>data</code>, which contains subfolders for each sample holding the graphs (PDF) and <code>json</code> config files.</li>
</ul>
<p>Along with the sam files resulting from the mapping procedure, PDF report(s) containing different mapping metrics is generated. The report also includes general information about the run, e.g. start time, executor and options. The first page of each PDF report contains an overview of all tool versions used in the pipeline, the parameters passed to the pipeline and the system characteristics. The second page summarizes several mapping metrics. The figure below shows a representative second page of the mapping report. The four figures show the following information:</p><ul>
<li>Top left: The maximum, average and minimum coverage over the length of the reference sequence.</li>
<li>Top right: The number of bases in the reference covered by different number of reads. The presence of distinct peaks in this graph may indicate potentially interesting events such as copy number variations.</li>
<li>Bottom left: The number of mapped reads vs. mapping qualities. Low mapping quality of majority of reads may indicate unsuitable reference sequence(s).</li>
<li><p class="startli">Bottom right: The maximum, average and minimum mapping quality over the length of the reference sequence.</p>
<div class="image">
<img src="../../report.png" alt="Example of the PDF report generated by the mapping pipeline."/>
</div>
</li>
</ul>
<p>Moreover, some additional metrics are documented in the PDF report:</p><ul>
<li>total reads</li>
<li>concordant reads</li>
<li>discordant reads</li>
<li>paired reads</li>
<li>mapped reads</li>
<li>unmapped reads</li>
<li>coverage graph</li>
<li>bases per coverage graph</li>
<li>reads per mapping quality graph</li>
<li>mapping quality graph</li>
<li>average coverage</li>
<li>maximum coverage</li>
<li>minimum coverage</li>
<li>standard deviation of coverage</li>
<li>number of bases with coverage of 0</li>
<li>number of bases with coverage &gt; mean+2*sd</li>
<li>number of bases with coverage &lt; mean+2*sd <hr/>
 <h2>Changelog</h2>
</li>
</ul>
<ul>
<li>4.1.0: Reworked readgroup assignment</li>
<li>4.0.0: Adaptions for wrapper pipeline</li>
<li>3.0.0: Individual Read Group Lib per sample</li>
<li>2.0.2: Parameter names are now unified across all RKI Bioinformatics Service Pipelines</li>
<li>2.0.1: Changed executable name</li>
<li>2.0: Initial release of the stable version</li>
<li>1.0: Initial version for internal testing <hr/>
 <h2>License</h2>
</li>
</ul>
<p>This program is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License, version 3 as published by the Free Software Foundation.</p>
<p>This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</p>
<p>You should have received a copy of the GNU Lesser General Public License along with this program. If not, see <a href="http://www.gnu.org/licenses/">http://www.gnu.org/licenses/</a>. </p>
</div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
